/* 
   Copyright 2002 Andrew Tridgell <tridge@samba.org>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   
*/

/*
   all global variiables in chessd have been moved here so that they can
   be maintained over a code reload. As long as the code reload does not change the
   shape or meaning of any of the following globals then the reload should work
*/


/* the EXTERN macro is used to allow ficsmain.c to declare real variables while
   other modules declare them as extern */
#ifndef EXTERN
#define EXTERN extern
#endif

/* from network.c */
EXTERN struct {
	int sockfd;
	int numConnections; 
	struct connection_t **con;
	int no_file;   /* number of files allowed */
	int no_conn;   /* number of connections allowed */
	int max_connections;
} net_globals;

/* from gamedb.c */
EXTERN struct {
	struct game *garray;
	int g_num;
} game_globals;

/* from playerdb.c */
EXTERN struct {
	struct player parray[PARRAY_SIZE];
	int p_num;
} player_globals;

/* from command.c */
EXTERN struct {
	time_t startuptime;
	int player_high;
	int game_high;
	int commanding_player;
} command_globals;

/* from gics.c */
EXTERN struct {
	struct userstat_type userstat;
} gics_globals;

/* from seekproc.c */
EXTERN struct {
	int quota_time;
	struct pending *pendlist;
	struct pending *pendadd;
	struct pending ads[MAXSOUGHT];
} seek_globals;

/* from timeseal.c */
EXTERN struct {
	int decoder_conn;
	FILE *decoder_f;
} timeseal_globals;

/* this is set to 1 when we need to do a code reload */
EXTERN unsigned chessd_reload_flag;
